# Example 3.1: The pig problem revisited
#
# First we plot the objective function
#
x=seq(0,40,0.1)
c=0.025
y=(0.65 - 0.01*x)*(200*exp(c*x)) - 0.45*x
plot(x,y,type="l")
#
# Next we define the function F(x) and its derivative F1(x).
# These functions were computed outside of R
# 
F<-function(x){F=200*c*(0.65-0.01*x)*exp(c*x)-2.0*exp(c*x)-0.45
    return(F)}
F1<-function(x){F1=200*c^2*(0.65-0.01*x)*exp(c*x)-4.0*c*exp(c*x)
    return(F1)}
#
# Now we run Newton's method
#
N=10
x=20 
for (i in 1:N){  
    x=x-F(x)/F1(x)
    print(x)}




