#particle tracking simulation for Example 9.6
N=10000; T=4000; M=100; A=.0131; alpha=1.1; v=0.12; Psafe=2
dt=T/M
dP=540/N
t=seq(0,T,T/M)
S <- array(0,c(N,length(t))) 
P=t
for (j in 1:length(P)){P[j]=0}
for (i in 1:N){
  S[i,0]=0
  U=runif(t)
  Z=(A/U)^(1/alpha)
  Z=Z-(A^(1/alpha))*alpha/(alpha-1)
  for (j in 1:M){
    S[i,j+1] = S[i,j]+v*dt+dt^(1/alpha)*Z[j]
    if (15<S[i,j+1] && S[i,j+1]<25) {P[j]=P[j]+dP/10}}}
#plot concentration over time
m=t
for (j in 0:length(t)){m[j]=Psafe} 
plot(t,P,type="l")
lines(t,m,lty="dashed")
#compute max conc and time to safe conc
Tmax=0; Pmax=0; Tsafe=0;
for (j in 1:M){
  if (P[j] > Pmax){Pmax=P[j]; Tmax=t[j]}
  if (P[j] > Psafe) {Tsafe=t[j]+dt}}
Tmax
Pmax
Tsafe
# output final particle locations for later use
write(S[,M],file="Sfinal.txt",ncolumns=1)

